function varargout=solve(self,varargin) 
  p = inputParser;
  p.addParamValue('solver',@mldivide,@(f) strcmp(class(f),'function_handle'));
  p.addParamValue('perm',[],@(f) strcmp(class(f),'function_handle') || isempty(f));
  p.addParamValue('local',true,@islogical);
  p.addParamValue('verbose',0,@isscalar);
  p.addParamValue('split',false,@islogical);
  p.parse(varargin{:});
  funsolve=p.Results.solver;
  perm=p.Results.perm;
  [Ag,bg]=self.Assembly('local',p.Results.local);
  if fc_tools.comp.isOctave(), varargout=cell(1,nargout); end % Needed by Octave
  if isempty(perm)
      varargout{:}=funsolve(Ag,bg);
      if p.Results.verbose>0
        res=norm(Ag*varargout{1}-bg,Inf);
        fprintf('[fc-vfemp1] BVP.solve, residu : %.16f\n',res)
      end
  else
    pe=perm(Ag);
    varargout{:}=funsolve(Ag(pe,pe),bg(pe));
    varargout{1}=varargout{1}(pe);
  end
  if p.Results.split
    varargout{1}=self.splitsol(varargout{1});
  end
end
